//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_Help.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_help {
//---------------------------------------------------------------------------
__fastcall THelpCommands::THelpCommands() :
	TCommands()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall THelpCommands::~THelpCommands()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall THelpCommands::OpenHelp()
{
	if(!CanOpenHelp()) {
		HandleFeatureUnavailable();
	}
	if(Application->MessageBox(
		"Do you want to open the offline help?",
		Application->Title.c_str(),
		MB_YESNO | MB_ICONEXCLAMATION | MB_SETFOREGROUND) != IDYES) {
		Abort();
	}
	SHELLEXECUTEINFO LExecuteInfo = {0};
	LExecuteInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	LExecuteInfo.fMask = SEE_MASK_FLAG_NO_UI;
	LExecuteInfo.lpVerb = "open";
	LExecuteInfo.lpFile = TCommon::HelpFile.c_str();
	LExecuteInfo.nShow = SW_SHOWNORMAL;
	if(!ShellExecuteEx(&LExecuteInfo)) {
		throw EAppError("The program could not open the help.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall THelpCommands::CanOpenHelp()
{
	return true;
}
//---------------------------------------------------------------------------
void __fastcall THelpCommands::ShowAbout()
{
	if(!CanShowAbout()) {
		HandleFeatureUnavailable();
	}
	Application->MessageBox(
		TCommon::About.c_str(),
		"About Dupy Scan",
		MB_OK | MB_ICONINFORMATION | MB_SETFOREGROUND);
}
//---------------------------------------------------------------------------
bool __fastcall THelpCommands::CanShowAbout()
{
	return true;
}
//---------------------------------------------------------------------------
} // End namespace App_help
//---------------------------------------------------------------------------

