//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_ProgressDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAppProgressDialog* AppProgressDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	ACanClose = false;
	if(ModalResult != mrOk) {
		DoCancel();
		return;
	}
	ActiveControl = NULL;
	ACanClose = true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppProgressDialog::GetMessage()
{
	return Label1->Caption;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::SetMessage(const AnsiString& AMessage)
{
	Label1->Caption = AMessage;
}
//---------------------------------------------------------------------------
int __fastcall TAppProgressDialog::GetCurrent()
{
	return ProgressBar1->Position;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::SetCurrent(int ACurrent)
{
	ProgressBar1->Position = ACurrent;
}
//---------------------------------------------------------------------------
int __fastcall TAppProgressDialog::GetAll()
{
	return ProgressBar1->Max;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::SetAll(int AAll)
{
	ProgressBar1->Max = AAll;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::DoCancel()
{
	if(OnCancel != NULL) {
		OnCancel(this);
	}
}
//---------------------------------------------------------------------------
TAppProgressDialog* __fastcall TAppProgressDialog::EnsureCreated()
{
	if(AppProgressDialog == NULL) {
		AppProgressDialog = new TAppProgressDialog(Application);
	}
	return AppProgressDialog;
}
//---------------------------------------------------------------------------
__fastcall TAppProgressDialog::TAppProgressDialog(TComponent* AOwner) :
	TForm(AOwner),
	FOnCancel(NULL)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TAppProgressDialog::~TAppProgressDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Execute()
{
	SelectFirst();
	ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Finish()
{
	ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::ShowProgress(int ACurrent, int AAll)
{
	All = AAll;
	Current = ACurrent;
}
//---------------------------------------------------------------------------
bool __fastcall TAppProgressDialog::IsCompleted()
{
	return Current == All;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Reset()
{
	Message = AnsiString();
	ShowProgress(0, 0);
}
//---------------------------------------------------------------------------

