//---------------------------------------------------------------------------
#ifndef App_ProgressDialogH
#define App_ProgressDialogH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class TAppProgressDialog : public TForm
{
__published:
	TButton* Button1;
	TLabel* Label1;
	TProgressBar* ProgressBar1;
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
private:
	TNotifyEvent FOnCancel;
	AnsiString __fastcall GetMessage();
	void __fastcall SetMessage(const AnsiString& AMessage);
	int __fastcall GetCurrent();
	void __fastcall SetCurrent(int ACurrent);
	int __fastcall GetAll();
	void __fastcall SetAll(int AAll);
protected:
	virtual void __fastcall DoCancel();
public:
	static TAppProgressDialog* __fastcall EnsureCreated();
	__fastcall TAppProgressDialog(TComponent* AOwner);
	virtual __fastcall ~TAppProgressDialog();
	virtual void __fastcall Execute();
	virtual void __fastcall Finish();
	virtual void __fastcall ShowProgress(int ACurrent, int AAll);
	virtual bool __fastcall IsCompleted();
	virtual void __fastcall Reset();
	__property AnsiString Message = {read=GetMessage, write=SetMessage};
	__property int Current = {read=GetCurrent, write=SetCurrent};
	__property int All = {read=GetAll, write=SetAll};
	__property TNotifyEvent OnCancel = {read=FOnCancel, write=FOnCancel};
};
//---------------------------------------------------------------------------
extern PACKAGE TAppProgressDialog* AppProgressDialog;
//---------------------------------------------------------------------------
#endif

