//---------------------------------------------------------------------------
#ifndef App_ScanTasksH
#define App_ScanTasksH
//---------------------------------------------------------------------------
#include "App_Document.h"
#include "Moa_Tasks.h"
//---------------------------------------------------------------------------
namespace App_scantasks {
//---------------------------------------------------------------------------
typedef void __fastcall (__closure * TScanTaskStatusEvent)(TObject* ASender, const AnsiString& AMessage);
//---------------------------------------------------------------------------
class TScanTask : public TTask
{
private:
	struct TCreateCommandArguments
	{
		TScanCommand* Command;
		__fastcall TCreateCommandArguments(TScanCommand* ACommand) :
			Command(ACommand) {}
	};
	struct TCommandMatchArguments
	{
		TObject* Sender;
		int Index;
		const TScanRecord& Record;
		__fastcall TCommandMatchArguments(TObject* ASender, int AIndex, const TScanRecord& ARecord) :
			Sender(ASender),
			Index(AIndex),
			Record(ARecord) {}
	};
	struct TCommandGroupArguments
	{
		TObject* Sender;
		int Index;
		const TScanRecord& Record;
		__fastcall TCommandGroupArguments(TObject* ASender, int AIndex, const TScanRecord& ARecord) :
			Sender(ASender),
			Index(AIndex),
			Record(ARecord) {}
	};
	struct TDoStatusArguments
	{
		const AnsiString& Message;
		__fastcall TDoStatusArguments(const AnsiString& AMessage) :
			Message(AMessage) {}
	};
	TDocument* FDocument;
	TScanTaskStatusEvent FOnStatus;
	TScanCommand* __fastcall CreateCommand();
	void __fastcall MatcherContinue(TObject* ASender, bool& ACanContinue);
	void __fastcall CommandMatching(TObject* ASender, int AIndex, const TScanRecord& ARecord);
	void __fastcall CommandMatch(TObject* ASender, int AIndex, const TScanRecord& ARecord);
	void __fastcall CommandGroup(TObject* ASender, int AIndex, const TScanRecord& ARecord);
	void __fastcall CommandProgress(TObject* ASender, int ACurrent, int AAll);
	void __fastcall CommandContinue(TObject* ASender, bool& ACanContinue);
	void __fastcall SynchronizedCreateCommand(void* AData);
	void __fastcall SynchronizedCommandMatching(void* AData);
	void __fastcall SynchronizedCommandMatch(void* AData);
	void __fastcall SynchronizedCommandGroup(void* AData);
	void __fastcall SynchronizedDoStatus(void* AData);
	__property TDocument* Document = {read=FDocument};
protected:
	virtual void __fastcall Execute();
	virtual void __fastcall DoStatus(const AnsiString& AMessage);
public:
	__fastcall TScanTask(TDocument* ADocument);
	virtual __fastcall TScanTask();
	virtual void __fastcall HandleCancel(TObject* ASender);
	__property TScanTaskStatusEvent OnStatus = {read=FOnStatus, write=FOnStatus};
};
//---------------------------------------------------------------------------
} // End namespace App_scantasks
using namespace App_scantasks;
//---------------------------------------------------------------------------
#endif

