//---------------------------------------------------------------------------
// Version: 2.0.0 Beta
// Date: 2012-09-08 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Hash/sha2.h"
#include "Hash/sha2.c"
#include "Moa_Hash.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moa_hash {
//---------------------------------------------------------------------------
__fastcall THashFunction::THashFunction() :
	TObject()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall THashFunction::~THashFunction()
{
	// Do nothing
}
//---------------------------------------------------------------------------
AnsiString __fastcall THashFunction::Finish()
{
	AnsiString LHash = Hash;
	Reset();
	return LHash;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TSha256HashFunction::Initialize()
{
	try {
		FContext = new sha2_context();
		sha2_starts(static_cast<sha2_context*>(Context));
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TSha256HashFunction::Uninitialize()
{
	delete static_cast<sha2_context*>(FContext);
	FContext = NULL;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TSha256HashFunction::GetHash()
{
	const int LBufferSize = 32;
	uchar LBuffer[LBufferSize];
	sha2_context LContext = *static_cast<sha2_context*>(Context);
	sha2_finish(&LContext, LBuffer);
	const int LHashSize = LBufferSize * 2;
	char LHash[LHashSize];
	BinToHex(LBuffer, LHash, LBufferSize);
	return AnsiString(LHash, LHashSize);
}
//---------------------------------------------------------------------------
__fastcall TSha256HashFunction::TSha256HashFunction() :
	THashFunction(),
	FContext(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TSha256HashFunction::~TSha256HashFunction()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TSha256HashFunction::Update(const byte* AData, int ADataLength)
{
	sha2_update(static_cast<sha2_context*>(Context), const_cast<byte*>(AData), ADataLength);
}
//---------------------------------------------------------------------------
void __fastcall TSha256HashFunction::Reset()
{
	sha2_starts(static_cast<sha2_context*>(Context));
}
//---------------------------------------------------------------------------
} // End namespace Moa_hash
//---------------------------------------------------------------------------

