//---------------------------------------------------------------------------
#ifndef Moa_HashH
#define Moa_HashH
//---------------------------------------------------------------------------
// Version: 2.0.0 Beta
// Date: 2012-09-08 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_hash {
//---------------------------------------------------------------------------
class EHashError : public Exception
{
public:
	__fastcall EHashError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class THashFunction : public TObject
{
private:
protected:
	virtual AnsiString __fastcall GetHash() = 0;
public:
	__fastcall THashFunction();
	virtual __fastcall ~THashFunction();
	virtual void __fastcall Update(const byte* AData, int ADataLength) = 0;
	virtual void __fastcall Reset() = 0;
	virtual AnsiString __fastcall Finish();
	__property AnsiString Hash = {read=GetHash};
};
//---------------------------------------------------------------------------
class TSha256HashFunction : public THashFunction
{
private:
	void* FContext;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	__property void* Context = {read=FContext};
protected:
	virtual AnsiString __fastcall GetHash();
public:
	__fastcall TSha256HashFunction();
	virtual __fastcall ~TSha256HashFunction();
	virtual void __fastcall Update(const byte* AData, int ADataLength);
	virtual void __fastcall Reset();
};
//---------------------------------------------------------------------------
} // End namespace Moa_hash
using namespace Moa_hash;
//---------------------------------------------------------------------------
#endif

