//---------------------------------------------------------------------------
#ifndef Moa_SetsH
#define Moa_SetsH
//---------------------------------------------------------------------------
// Version: 2.0.0 Beta
// Date: 2012-08-20 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_sets {
//---------------------------------------------------------------------------
template <typename T, unsigned char MinElement, unsigned char MaxElement>
class TSetUtilities
{
public:
	typedef Set<T, MinElement, MaxElement> TSet;
private:
protected:
public:
	static TSet __fastcall Not(const TSet& ASet)
	{
		TSet LSet = ASet;
		for(int LI = 0; LI < MaxElement - MinElement + 1; ++LI) {
			if(!ASet.Contains(static_cast<T>(MinElement + LI))) {
				LSet << static_cast<T>(MinElement + LI);
			}
		}
		return LSet;
	}
	static TSet __fastcall Xor(const TSet& ASet1, const TSet& ASet2)
	{
		return ASet1 * Not(ASet2);
	}
	static TSet __fastcall FromString(const AnsiString& AString)
	{
		TSet LSet;
		for(int LI = 0; LI < MaxElement - MinElement + 1; ++LI) {
			if(AString[LI + 1] != '0') {
				LSet << static_cast<T>(MinElement + LI);
			}
		}
		return LSet;
	}
	static AnsiString __fastcall ToString(const TSet& ASet)
	{
		AnsiString LString = AnsiString::StringOfChar('0', MaxElement - MinElement + 1);
		for(int LI = 0; LI < MaxElement - MinElement + 1; ++LI) {
			if(ASet.Contains(static_cast<T>(MinElement + LI))) {
				LString[LI + 1] = '1';
			}
		}
		return LString;
	}
	static int __fastcall CountElements(const TSet& ASet)
	{
		int LCount = 0;
		for(int LI = 0; LI < MaxElement - MinElement + 1; ++LI) {
			if(ASet.Contains(static_cast<T>(MinElement + LI))) {
				++LCount;
			}
		}
		return LCount;
	}
};
//---------------------------------------------------------------------------
} // End namespace Moa_sets
using namespace Moa_sets;
//---------------------------------------------------------------------------
#endif

