//---------------------------------------------------------------------------
#ifndef Moa_ShellFilesH
#define Moa_ShellFilesH
//---------------------------------------------------------------------------
// Version: 1.4.0 Beta
// Date: 2012-08-16 UTC+09:00
// Version: 1.3.0
// Date: 2012-08-21 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_shellfiles {
//---------------------------------------------------------------------------
class EShellFileError : public Exception
{
public:
	__fastcall EShellFileError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TFileTypeCache : public TObject
{
private:
	class TEntry : public TObject
	{
	private:
		AnsiString FDescription;
		static AnsiString __fastcall Determine(const AnsiString& AFile, bool AAsDirectory);
	protected:
	public:
		__fastcall TEntry();
		__fastcall TEntry(const AnsiString& AFile);
		virtual __fastcall ~TEntry();
		__property AnsiString Description = {read=FDescription};
	};
	TStringList* FExtensions;
	TEntry* FDirectory;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	__property TStringList* Extensions = {read=FExtensions};
	__property TEntry* Directory = {read=FDirectory};
protected:
public:
	__fastcall TFileTypeCache();
	virtual __fastcall ~TFileTypeCache();
	virtual AnsiString __fastcall Determine(const AnsiString& AFile);
	virtual AnsiString __fastcall DetermineAsRegularFile(const AnsiString& AFile);
	virtual AnsiString __fastcall DetermineAsDirectory();
	virtual void __fastcall Clear();
};
//---------------------------------------------------------------------------
class TSpecialShellFiles
{
private:
protected:
public:
	static AnsiString __fastcall Determine(UINT AId);
	static AnsiString __fastcall GetApplicationData();
	static AnsiString __fastcall GetDesktop();
	static AnsiString __fastcall GetDocuments();
	static AnsiString __fastcall GetFavorites();
	static AnsiString __fastcall GetProgramFiles();
	static AnsiString __fastcall GetPrograms();
	static AnsiString __fastcall GetStartMenu();
};
//---------------------------------------------------------------------------
class TShellFileUtilities
{
private:
	static char* __fastcall MakePaths(const TStringDynArray& APaths);
protected:
public:
	static bool __fastcall Delete(const TStringDynArray& AFiles, bool AAllowUndo);
};
//---------------------------------------------------------------------------
} // namespace Moa_shellfiles
using namespace Moa_shellfiles;
//---------------------------------------------------------------------------
#endif

